/*
	Vertris v0.3.2
	Copyright (C) 2006 - 2007, Andrs Rassol
	
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <string.h>

#include "vertris.h"

#include <allegro.h>

extern int FX;

extern SAMPLE Lineclear;

extern unsigned int Lines, Level;

extern char Vertris[VERTRIS_W][VERTRIS_H];
extern char FXVertris[VERTRIS_W][VERTRIS_H];

extern Vertromino Vertro;

char valid_pos(int x, int y)
{
	int i, j;

	for (i = MAX_VERTROMINO; i--; )
		for (j = MAX_VERTROMINO; j--; )
			if (Vertro.shape[i][j])
				if (x + i > VERTRIS_W - 1 || x + i < 0 || y + j < 0)
					return 0;
				else if (y + j < VERTRIS_H && Vertris[x + i][y + j])
					return 0;

	return 1;
}

void vert_setpiece()
{
	unsigned int i, j;

	for (i = MAX_VERTROMINO; i--; )
		for (j = MAX_VERTROMINO; j--; )
			if (Vertro.shape[i][j])
			{
				if (Vertro.y + j > VERTRIS_H - 1)
				{
					hiscores();
					return;
				}

				Vertris[Vertro.x + i][Vertro.y + j] = Vertro.shape[i][j];
			}
}

static char vert_line(char j)
{
	unsigned int i;

	for (i = VERTRIS_W; i--; )
		if (!Vertris[i][j])
			return 0;

	return 1;
}

int level()
{
	int i, j;
	
	for (i = VERTRIS_H; i--; )
		for (j = VERTRIS_W; j--; )
			if (Vertris[j][i])
				return i + 1;

	return 0;
}

void vert_lineclear()
{
	unsigned int i, j;

	for (j = Level; j--; )
		if (vert_line(j))
		{
			for (i = VERTRIS_W; i--; )
				FXVertris[i][j] = 2;

			output();
			rest(100);

			for (i = VERTRIS_W; i--; )
				FXVertris[i][j] = 4;

			output();
			rest(200);

			for (i = VERTRIS_W; i--; )
			{
				Vertris[i][j] = 0;
				FXVertris[i][j] = 0;
			}

			output();
			rest(50);

			Lines++;

			for (i = VERTRIS_W; i--; )
				memmove(&Vertris[i][j], &Vertris[i][j + 1], (VERTRIS_H - 1) - j);

			for (i = 0; i < VERTRIS_W; i++)
				Vertris[i][VERTRIS_H - 1] = 0;

			output();

			reset_ticks();
		}
}
